"""encodings

This module implements some basic support for conversions between
ucs4 character data (stored in an array object) and various
character encodings.
"""

from array import array

class WStringError(ValueError):
    pass

# Find a typecode for a 4 byte signed type
for typecode in ['b','h','i','l',None]:
    if not typecode:
        raise ValueError('No suitable typecode')
    if array(typecode).itemsize==4:
        break

# The ucs4 encoding used by the wstring module must use instances of array.array,
# with the typecode calculated above
