from array import array
from encodings import typecode, WStringError

def utf8_to_ucs4(s,_size_map=[1]*128 + [None]*64 + [2]*32 + [3]*16 + [4]*8 + [5]*4 + [6]*2 + [None]*2,
                   _lead_mask_map=[None, 0x7f, 0x1f, 0xf, 0x7, 0x3, 0x1],
                   ord=ord):
    i = 0
    n = len(s)
    a = array(typecode)
    while i!=n:
        lead = ord(s[i])
        size = _size_map[lead]
        if not size:
            raise WStringError('Invalid UTF-8 encoding')
        c = lead & _lead_mask_map[size]
        end = i+size
        while 1:
            i = i+1
            if i>=end:
                break
            b = ord(s[i])
            if b&0xc0 != 0x80:
                raise WStringError('Invalid UTF-8 encoding')
            c = ( c<<6 ) + ( 0x3f & b )
        a.append(c)
    return a

def ucs4_to_utf8(a,chr=chr):
    o = ''
    for c in a:
        if c<0:
            raise WStringError('Invalid UCS-4 character')
        if c<=0x7f:
            o = o+chr(c)
        else:
            r = ''
            mask = 0xff80
            for ceiling in [0x7f, 0x1f, 0xf, 0x7, 0x3, 0x1]:
                if c>ceiling:
                    r = chr(0x80|(c&0x3f)) + r
                    c = c>>6
                    mask = mask>>1
                else:
                    o = o + chr((mask|(c&0x3f))&0xff) + r
                    break
    return o
